function [rho,kT]=fmdkT(P,T,coefrho,coeflogkT,vdWd,phi)


% % Convert the column and the row into matrices
% [T,P]=meshgrid(T,P);
% Calculation of polynomial approximations for the the reference density, 
% compressibility and their derivatives
rhos=polyval(coefrho{1},T,[],coefrho{2});
drhos=polyval(polyder(coefrho{1}),T,[],coefrho{2})/coefrho{2}(2);
kTs=exp(polyval(coeflogkT{1},T,[],coeflogkT{2}));
dlogkTs=polyval(polyder(coeflogkT{1}),T,[],coeflogkT{2})/coeflogkT{2}(2);
% Calculation of the FT-EoS's parameter
k=-1./rhos-(1./T+dlogkTs)./drhos;
% Reference (atmospheric) pressure in MPa
P0=0.101325;
% Transition density and pressure
rhotr=phi*vdWd;
Ptr=(exp(k.*(rhotr-rhos))-1)./(k.*rhos.*kTs)*1e-6;
kTtr=kTs.*exp(-k.*(rhotr-rhos))./(rhotr./rhos);
lambda=k.*rhos;
lambdam=lambda;
ilambdam=1./(lambda);

% FT-EoS continued by Murnaghan'e equation as a matrix output
rho=zeros(length(P),length(T));
kT=zeros(length(P),length(T));
for j=1:length(T)
    rho(P<=Ptr(j),j)=rhos(j)+k(j).^(-1).*log(k(j).*rhos(j).*kTs(j).*(P(P<=Ptr(j))-P0)*1e6+1);
    rho(P>Ptr(j),j)=rhotr.*(lambdam(j).*kTtr(j).*1e6.*(P(P>Ptr(j))-Ptr(j))+1).^ilambdam(j);     
    kT(P<=Ptr(j),j)=kTs(j)./(k(j).*rhos(j).*kTs(j).*(P(P<=Ptr(j))-P0)*1e6+1).*(rhos(j)./rho(P<=Ptr(j),j));
    kT(P>Ptr(j),j)=kTtr(j)./(lambdam(j).*kTtr(j).*1e6.*(P(P>Ptr(j))-Ptr(j))+1);
end

